on *:input:*: {
  ;Check if CheerUp Text is enabled in channels en query's
  if ($readini(%cheerupini,setup,enabled)) && (($active ischan) || ($readini(%cheerupini,setup,query))) {
    ;If rules for channel/network are 1, don't replace anything
    if ($readini(%cheerupini,rules,$network) != 1) && ($readini(%cheerupini,rules,$chan) != 1) {
      ;If / is prefix and first words starts with / check if the word could be replaced
      if ($left($1,1) == /) && ($gettok($1,1,47) !isin $readini(%cheerupini,setup,words)) return
      if ($active !ischan) && (!$query($active)) halt
      var %a = $1-, %t = $readini(%cheerupini,setup,words), %i = $numtok(%t,59), %c = 1
      var %spf = $readini(%cheerupini,setup,spacefront)
      var %spb = $readini(%cheerupini,setup,spacebehind)
      while (%c <= %i) {
        ;W = Word 
        var %w = $gettok(%t,%c,59)
        ;WP = Word with Prefix
        var %wp = $+($chr($readini(%cheerupini,setup,prefix)), %w)
        ;WPS= Word with Prefix and Spaces 
        var %wps = $+($iif(%spf,$chr(32)), %wp, $iif(%spb,$chr(32)))
        ;RP = ReplaceWord
        var %rp = $readini(%cheerupini,words,%w)
        ;RPS = ReplaceWord with Spaces
        var %rps = $+($iif(%spf,$chr(32)), %rp, $iif(%spb,$chr(32)))
        ;CS = CaseSensitive
        %cs = $readini(%cheerupini,setup,casesens)

        if ($readini(%cheerupini,setup,option) == 1) || (($readini(%cheerupini,setup,option) == 3) && ($1 == $1-)) {
          if (%cs) var %a = $replacecs(%a, $+($iif(%spf,$chr(32)), %wp, $iif(%spb,$chr(32))), %rps)
          else var %a = $replace(%a, $+($iif(%spf,$chr(32)), %wp, $iif(%spb,$chr(32))), %rps)

          ;N = Number of words in line
          var %n = $numtok(%a,32)

          ;If spacefront, check if first word has to be replaced too
          ;F = First word
          var %f = $gettok(%a,1,32)
          if (%spf) {
            ;Mind Case Sensitivity
            if (%cs) {
              ;If Space behind, the first word will just be replaced
              if (%spb) { if (%f === %wp) var %a = %rps $gettok(%a,2- $+ %n,32) }
              ;Else a part of the first word will be replaced
              else var %a = $replacecs(%f,%wp,%rps) $gettok(%a,2- $+ %n,32)
            }
            else {
              ;If Space behind, the first word will just be replaced
              if (%spb) { if (%f == %wp) var %a = %rps $gettok(%a,2- $+ %n,32) }
              ;Else a part of the first word will be replaced
              else var %a = $replace(%f,%wp,%rps) $gettok(%a,2- $+ %n,32)
            }
          }
          ;If spacebehind, check if last word has to be replaced too
          ;L = Last word
          var %l = $gettok(%a,%n,32)
          if (%spb) {
            if (%cs) { if (%l === %wp) var %a = $gettok(%a,1- $+ $calc(%n -1),32) %rps }
            elseif (%l === %wp) var %a = $gettok(%a,1- $+ $calc(%n -1),32) %rps
          }
        }

        if ($readini(%cheerupini,setup,option) == 2) {
          ;N = Number of words in line
          var %n = $numtok(%a,32)
          var %f = $gettok(%a,1,32)
          if (%f == %wp) var %a = %rps $gettok(%a,2- $+ %n,32)
        }

        inc %c
      }
      var %a = $stylereplace(%a)
      ;Special rules
      ;1. Don't replace anything
      ;2. Only replace text
      ;3. Replace without colors
      if ($readini(%cheerupini,rules,$network) == 2) || ($readini(%cheerupini,rules,$chan) == 2) var %a = $strip(%a)
      if ($readini(%cheerupini,rules,$network) == 3) || ($readini(%cheerupini,rules,$chan) == 3) var %a = $strip(%a,c)
      msg $active %a
      halt
    }
  }
}

alias cheerupsetup {
  if ($dialog(cheerup)) dialog -v cheerup
  else {
    cheerupprev
    if (!$exists(%cheerupcolor)) cheerupcolor
    %cheerup.prefix = $chr($readini(%cheerupini,setup,prefix))

    dialog -m cheerup cheerup
  }
}

menu channel {
  -
  Cheer-Up Text: cheerupsetup
}

dialog cheerup {
  title Cheer-Up Text
  option dbu
  size -1 -1 200 150

  tab "Se&tup", 1, 2 0 195 106
  tab "&Words", 2, 2 0 195 106
  tab "&Usage", 8, 2 0 195 106
  tab "&About", 7, 2 0 195 106

  button "&Save", 3, 2 138 30 11
  button "&OK", 4, 168 138 30 11, default

  icon 5, 2 109 195 28, %cheerupbmp, noborder
  text v $+ $cheerupversion, 6, 172 95 20 8, disable right

  box "General settings", 100, 5 16 189 88, tab 1
  text "Style for style 1 <s1> :", 101, 8 24 62 8, right tab 1
  check "Underline", 102, 76 22 32 11, tab 1
  check "Bold", 103, 112 22 19 11, tab 1
  text "Color:", 104, 135 24 20 8, tab 1
  combo 105, 151 22 24 11, drop tab 1
  icon 106, 178 22 11 11, %cheerupcolor, noborder tab 1

  text "Style for style 2 <s2> :", 111, 8 36 62 8, right tab 1
  check "Underline", 112, 76 34 32 11, tab 1
  check "Bold", 113, 112 34 19 11, tab 1
  text "Color:", 114, 135 36 20 8, tab 1
  combo 115, 151 34 24 11, drop tab 1
  icon 116, 178 34 11 11, %cheerupcolor, noborder tab 1

  text "Prefix symbol :", 120, 8 48 62 8, right tab 1
  edit %cheerup.prefix, 121, 76 46 32 11, limit 1 tab 1
  check "&None", 122, 112 48 30 8, tab 1
  text "To replace there must be:", 130, 8 59 62 8, right tab 1
  check "A space in &front of the word", 131, 76 58 80 8, tab 1
  check "A space &behind the word", 132, 76 67 80 8, tab 1
  check "Or char", 133, 157 58 30 8, tab 1
  check "Or char", 134, 157 67 30 8, tab 1
  text "Replace:" , 140, 8 76 62 8, right tab 1
  radio "&All words in text", 141, 76 76 80 8, tab 1
  radio "Only &1st word of text", 142, 76 84 80 8, tab 1
  radio "If text is one &single word", 143, 76 92 80 8, tab 1

  box "Word list", 200, 5 16 189 88, tab 2
  combo 201, 8 24 62 80, sort tab 2
  edit "", 202, 73 24 117 30, multi vsbar tab 2
  button "&Add", 203, 73 55 22 11, tab 2
  button "&Del", 204, 73 67 22 11, tab 2
  button "<s&1>", 205, 145 55 22 11, tab 2
  button "<s&2>", 206, 168 55 22 11, tab 2
  button "<s1><s2>", 207, 145 67 45 11, hide tab 2
  button "<s1> <s2>", 208, 145 79 45 11, hide tab 2
  check "&Case sensitive", 209, 73 94 45 8, tab 2

  box "Usage", 800, 5 16 189 88, tab 8
  check "Cheer-Up Text enabled", 801, 8 23 80 8, tab 8
  list 803, 8 31 160 44, tab 8 extsel sort
  check "Use in query chat too", 804, 88 23 80 8, tab 8
  text "On:", 810, 8 72 10 8, tab 8
  edit "", 811, 18 71 80 11, tab 8
  text "Rules:", 812, 101 72 20 8, tab 8
  button "Copy active chan", 820, 17 82 82 11, tab 8
  button "Copy active network", 821, 17 93 82 11, tab 8
  radio "1. Don't replace anything", 831, 117 71 70 8, tab 8
  radio "2. Only replace text", 832, 117 79 70 8, tab 8
  radio "3. Replace without colors", 833, 117 87 70 8, tab 8
  button "&Add", 840, 169 31 22 11, tab 8
  button "&Del", 841, 169 43 22 11, tab 8

  box "About", 700, 5 16 189 88, tab 7
  text You're using 'Cheer-Up Text' v $+ $cheerupversion , 701, 28 24 90 8, tab 7
  text "Made by DJ_Toyz (aka To1ne)", 702, 28 35 80 8, tab 7
  text "You can read the online PDF helpfile", 703, 28 46 86 8, tab 7
  link "here", 704, 116 46 20 8, tab 7  
  text "Or download the most recent version", 705, 28 53 90 8, tab 7
  link "here", 706, 119 53 20 8, tab 7
  text "Or just look at", 707, 28 60 35 8, tab 7
  link "www.mircscripts.org", 708, 64 60 50 8, tab 7
  text "If there are any questions, bugs or suggestions mail to:", 709, 28 71 150 8, tab7
  link "to1ne@hotmail.com", 710, 28 78 60 8, tab 7
  icon 711, 145 20 48 48, $scriptdirIcon.png, tab 7
  button "Advertise on current channel" 712, 28 86 80 11, tab 7
}

on *:dialog:cheerup:init:*: {
  dll MDX\mdx.dll SetMircVersion $version
  dll MDX\mdx.dll MarkDialog $dname $dialog($dname).hwnd
  dll MDX\mdx.dll SetControlMDX 803 listview showsel report infotip rowselect > MDX\views.mdx

  did -i cheerup 803 1 headerdims 150:1 160:2
  did -i cheerup 803 1 headertext 0 Network/Channel $+ $chr(9) $+ Rules

  did -h cheerup 133,134
  didtok cheerup 105,115 59 0;1;2;3;4;5;6;7;8;9;10;11;12;13;14;15
  var %1 = $readini(%cheerupini,setup,style1)
  if ($gettok(%1,1,59) = 1) did -c cheerup 102
  if ($gettok(%1,2,59) = 1) did -c cheerup 103
  did -c cheerup 105 $calc($gettok(%1,3,59) + 1)
  cheerupcolor $gettok(%1,3,59) 106

  var %2 = $readini(%cheerupini,setup,style2)
  if ($gettok(%2,1,59) = 1) did -c cheerup 112
  if ($gettok(%2,2,59) = 1) did -c cheerup 113
  did -c cheerup 115 $calc($gettok(%2,3,59) + 1)
  cheerupcolor $gettok(%2,3,59) 116

  if ($readini(%cheerupini,setup,prefix) == 0) did -c cheerup 122
  if ($readini(%cheerupini,setup,spacefront) == 1) did -c cheerup 131
  else did -b cheerup 133
  if ($readini(%cheerupini,setup,spacebehind) == 1) did -c cheerup 132
  else did -b cheerup 134
  if ($readini(%cheerupini,setup,charfront) == 1) did -c cheerup 133
  if ($readini(%cheerupini,setup,charbehind) == 1) did -c cheerup 134
  did -c cheerup $+(14,$readini(%cheerupini,setup,option))

  if ($readini(%cheerupini,setup,casesens) == 1) did -c cheerup 209

  cheerupwordlist
  did -c cheerup 201 1
  cheerupruleslist
  var %i = $did(cheerup,201,1), %t = $readini(%cheerupini,words,%i)
  if (%t) { cheerupprev %i | did -ra cheerup 202 $readini(%cheerupini,words,%i) }

  if ($readini(%cheerupini,setup,enabled) == 1) did -c cheerup 801
  if ($readini(%cheerupini,setup,query) == 1) did -c cheerup 804
}

on *:dialog:cheerup:edit:*: {
  if ($did == 121) did -u cheerup 122

  if ($did == 201) {
    var %w = $readini(%cheerupini,setup,words)
    var %i = $did(cheerup,201)
    if ($istok(%w,%i,59)) {
      did -ra cheerup 202 $readini(%cheerupini,words,%i)
      cheerupprev %i
      did -c cheerup 201 $findtok($sorttok(%w,59),%i,59)
    }
    else did -r cheerup 202
  }
}

on *:dialog:cheerup:sclick:*: {
  if ($did == 3) {
    writeini %cheerupini setup style1 $+($did(102).state,;,$did(103).state,;,$calc($did(cheerup,105).sel -1))
    writeini %cheerupini setup style2 $+($did(112).state,;,$did(113).state,;,$calc($did(cheerup,115).sel -1))
    writeini %cheerupini setup prefix $iif($did(cheerup,121),$asc($did(cheerup,121)),0)
    writeini %cheerupini setup spacefront $did(cheerup,131).state
    writeini %cheerupini setup spacebehind $did(cheerup,132).state
    writeini %cheerupini setup charfront $did(cheerup,133).state
    writeini %cheerupini setup charbehind $did(cheerup,134).state
    writeini %cheerupini setup option $iif($did(cheerup,141).state,1,$iif($did(cheerup,142).state,2,3))
    writeini %cheerupini setup casesens $did(cheerup,209).state
    writeini %cheerupini setup enabled $did(cheerup,801).state
    writeini %cheerupini setup query $did(cheerup,804).state
  }
  if ($did == 4) { dialog -x cheerup | halt }

  if ($did == 102) { 
    var %1 = $readini(%cheerupini,setup,style1)
    writeini %cheerupini setup style1 $puttok(%1,$did(cheerup,102).state,1,59)
    cheerupprev
  }
  if ($did == 103) { 
    var %1 = $readini(%cheerupini,setup,style1)
    writeini %cheerupini setup style1 $puttok(%1,$did(cheerup,103).state,2,59)
    cheerupprev
  }
  if ($did == 105) {
    var %i = $did(cheerup,105).sel - 1
    cheerupcolor %i 106
    var %1 = $readini(%cheerupini,setup,style1)
    writeini %cheerupini setup style1 $puttok(%1,$calc($did(cheerup,105).sel -1),3,59)
    cheerupprev
  }
  if ($did == 112) { 
    var %2 = $readini(%cheerupini,setup,style2)
    writeini %cheerupini setup style2 $puttok(%2,$did(cheerup,112).state,1,59)
    cheerupprev
  }
  if ($did == 113) { 
    var %2 = $readini(%cheerupini,setup,style2)
    writeini %cheerupini setup style2 $puttok(%2,$did(cheerup,113).state,2,59)
    cheerupprev
  }
  if ($did == 115) {
    var %i = $did(cheerup,115).sel - 1
    cheerupcolor %i 116
    var %2 = $readini(%cheerupini,setup,style2)
    writeini %cheerupini setup style2 $puttok(%2,$calc($did(cheerup,115).sel -1),3,59)
    cheerupprev
  }
  if ($did == 122) {
    if ($did(cheerup,122).state)  did -r cheerup 121
    else did -f cheerup 121
  }
  if ($did == 131) || ($did == 132) {
    if ($did(cheerup,$did).state) did -e cheerup $calc($did + 2)
    else did -b cheerup $calc($did + 2)
  }

  if ($did == 201) {
    var %i = $did(cheerup,201,$did(cheerup,201,1).sel), %t = $readini(%cheerupini,words,%i)
    if (%t) { cheerupprev %i | did -ra cheerup 202 $readini(%cheerupini,words,%i) }
  }
  if ($did == 203) {
    var %i = $did(cheerup,201), %t = $+($did(cheerup,202,1),$did(cheerup,202,2),$did(cheerup,202,3),$did(cheerup,202,4),$did(cheerup,202,5),$did(cheerup,202,6),$did(cheerup,202,7),$did(cheerup,202,8),$did(cheerup,202,9),$did(cheerup,202,10))
    writeini %cheerupini words %i $iif(%t,%t, _)
    if (!$findtok($readini(%cheerupini,setup,words),%i,1,59)) {
      writeini %cheerupini setup words $addtok($readini(%cheerupini,setup,words),%i,59)
      did -a cheerup 201 %i
      did -c cheerup 201 $findtok($sorttok($readini(%cheerupini,setup,words),59),%i,59)
    }
    cheerupprev %i
  }
  if ($did == 204) {
    var %i = $did(cheerup,201)
    remini %cheerupini words %i
    writeini %cheerupini setup words $remtok($readini(%cheerupini,setup,words),%i,1,59) $+ ;
    did -d cheerup 201 $did(cheerup,201).sel
    did -r cheerup 202
    did -c cheerup 201 1
    cheerupprev
  }
  if ($did == 205) || ($did == 206) || ($did == 207) || ($did == 208) {
    var %s = $did(cheerup,202,1).selstart, %e = $did(cheerup,202,1).selend, %t = $replace($+($did(cheerup,202,1),$did(cheerup,202,2),$did(cheerup,202,3),$did(cheerup,202,4),$did(cheerup,202,5),$did(cheerup,202,6),$did(cheerup,202,7),$did(cheerup,202,8),$did(cheerup,202,9),$did(cheerup,202,10)),$chr(32),$chr(1))
    var %i = $remove($did(cheerup,$did),&), %l = $len(%t)
    did -ra cheerup 202 $replace($+($left(%t,%s), %i, $mid(%t,$calc(%e + 1),%l)),$chr(1),$chr(32))
    did -f cheerup 202
    if ($did == 205) || ($did == 206) did -ra cheerup $did $replace($did(cheerup,$did),<s,</q,</s,<s,</q,</s)
    else { did -ra cheerup 205 $replace($did(cheerup,205),<s,</q,</s,<s,</q,</s) | did -ra cheerup 206 $replace($did(cheerup,206),<s,</q,</s,<s,</q,</s) }

    if (/ isin $did(cheerup,205)) && (/ !isin $did(cheerup,206)) {
      did -ra cheerup 207 </s1><s2>
      did -ra cheerup 208 </s1> <s2>
      did -v cheerup 207,208
    }
    elseif (/ !isin $did(cheerup,205)) && (/ isin $did(cheerup,206)) {
      did -ra cheerup 207 </s2><s1>
      did -ra cheerup 208 </s2> <s1>
      did -v cheerup 207,208
    }
    elseif (/ isin $did(cheerup,205)) && (/ isin $did(cheerup,206)) {
      did -ra cheerup 207 </s2></s1>
      did -ra cheerup 208 </s2> </s1>
      did -v cheerup 207,208
    }
    else did -h cheerup 207,208
  }
  if ($did == 209) cheerupwordlist

  if ($did == 704) run http://users.telenet.be/DJ_Toyz/mIRC/Cheer-Up%20Readme.pdf
  if ($did == 706) run http://users.telenet.be/DJ_Toyz/mIRC/CheerUp.zip
  if ($did == 708) run http://www.mircscripts.org
  if ($did == 710) run mailto:to1ne@hotmail.com
  if ($did == 712) && ($active ischan) {
    var %a = <s1>U</s1><s2>sing</s2> <s1>C</s1><s2>heer-</s2><s1>U</s1><s2>p</s2> <s1>T</s1><s2>ext</s2> $&
      12 $+ $cheerupversion <s2>- get it at12 http://www.mircscripts.org/comments.php?cid=2699 
    var %a = $stylereplace(%a)
    ;Special rules
    ;1. Don't replace anything
    ;2. Only replace text
    ;3. Replace without colors
    if ($readini(%cheerupini,rules,$network) == 1) || ($readini(%cheerupini,rules,$chan) == 1) var %a = $strip(%a)
    if ($readini(%cheerupini,rules,$network) == 2) || ($readini(%cheerupini,rules,$chan) == 2) var %a = $strip(%a)
    if ($readini(%cheerupini,rules,$network) == 3) || ($readini(%cheerupini,rules,$chan) == 3) var %a = $strip(%a,c)
    msg $active %a
  }

  if ($did == 801) {
    if ($did(cheerup,$did).state) did -e cheerup 804
    else did -b cheerup 804
  }
  if ($did == 820) if ($active ischan) { did -ra cheerup 811 $active } | else { did -r cheerup 811 }
  if ($did == 821) did -ra cheerup 811 $network
  if ($did == 840) {
    if ($did(cheerup,811)) {
      if ($did(cheerup,831).state) || ($did(cheerup,832).state) || ($did(cheerup,833).state) {
        var %t = $did(cheerup,811)
        if ($did(cheerup,831).state) var %s = 1
        elseif ($did(cheerup,832).state) var %s = 2
        else var %s = 3
        writeini %cheerupini rules %t %s
        if ($findtok($readini(%cheerupini,setup,rules),%t,1,59)) {
          var %i = 2, %l = $did(cheerup,803).lines
          while (%i <= %l) {
            did -c cheerup 803 %i
            if ($gettok($gettok($did(cheerup,803).seltext,1,9),6,32) == %t) did -d cheerup 803 $did(cheerup,803).sel
            inc %i
          }
        }
        else {
          writeini %cheerupini setup rules $addtok($readini(%cheerupini,setup,rules),%t,59)
        }
        did -i cheerup 803 2 %t $+ $chr(9) $+ $cheeruprulesnr(%s)
        did -r cheerup 811
        did -u cheerup 831, 832, 833
      }
      else var %e = $?!="You didn't select rules for" $did(cheerup,811)
    }
    else var %e = $?!="You didn't fill in a channel or network"
  }
  if ($did == 841) {
    var %i = $gettok($gettok($did(cheerup,803).seltext,1,9),6,32)
    remini %cheerupini rules %i
    writeini %cheerupini setup rules $remtok($readini(%cheerupini,setup,rules),%i,1,59) $+ ;
    did -d cheerup 803 $did(cheerup,803).sel
    did -r cheerup 811
    did -u cheerup 831, 832, 833
  }
}

on *:dialog:cheerup:dclick:*: {
  if ($did == 5) cheerupprev
}

alias -l cheerupprev {
  window -pBh +d @cheerupprev 0 0 390 56
  if ($1) var %i = $1
  elseif ($dialog(cheerup)) var %i = $did(cheerup,201,$did(cheerup,201,1).sel)
  else var %i = $gettok($readini(%cheerupini,setup,words),1,59)
  if (!%i) %t = $stylereplace(<s1>L</s1><s2>aughing</s2> <s1>O</s1><s2>ut</s2> <s1>L</s1><s2>oud</s2>)
  else var %t = $stylereplace($readini(%cheerupini,words,%i))
  drawtext -p @cheerupprev 0 3 2 %t
  drawsave @cheerupprev %cheerupbmp
  window -c @cheerupprev
  if ($dialog(cheerup)) did -g cheerup 5 %cheerupbmp
}

alias -l cheerupcolor {
  window -pBh +d @cheerupcolor 0 0 15 15
  if ($1) var %i = $1
  else var %i = 0
  drawfill @cheerupcolor %i %i 0 0
  drawsave @cheerupcolor %cheerupcolor
  window -c @cheerupcolor
  if ($dialog(cheerup)) did -g cheerup $2 %cheerupcolor
}

alias -l cheerupwordlist {
  var %i = 1, %t = $readini(%cheerupini,setup,words), %n = $numtok(%t,59)
  did -r cheerup 201
  while (%i <= %n) {
    if ($did(cheerup,209).state) did -a cheerup 201 $gettok(%t,%i,59)
    else did -a cheerup 201 $lower($gettok(%t,%i,59))
    inc %i
  }
}

alias -l cheerupruleslist {
  var %i = 1, %t = $readini(%cheerupini,setup,rules), %n = $numtok(%t,59)
  did -r cheerup 803
  while (%i <= %n) {
    did -a cheerup 803 $gettok(%t,%i,59) $+ $chr(9) $+ $cheeruprulesnr($readini(%cheerupini,rules,$gettok(%t,%i,59)))
    inc %i
  }
}

alias -l stylereplace {
  var %1 = $readini(%cheerupini,setup,style1)
  var %style1 = $+($chr(3), $gettok(%1,3,59), $iif($gettok(%1,1,59),$chr(31)), $iif($gettok(%1,2,59),$chr(2)))
  var %style01 = $+($chr(3), $iif($gettok(%1,1,59),$chr(31)), $iif($gettok(%1,2,59),$chr(2)))
  var %2 = $readini(%cheerupini,setup,style2)
  var %style2 = $+($chr(3), $gettok(%2,3,59), $iif($gettok(%2,1,59),$chr(31)), $iif($gettok(%2,2,59),$chr(2)))
  var %style02 = $+($chr(3), $iif($gettok(%2,1,59),$chr(31)), $iif($gettok(%2,2,59),$chr(2)))

  var %style12 = $+($iif($gettok(%1,1,59) != $gettok(%2,1,59),$chr(31)), $iif($gettok(%1,2,59) != $gettok(%2,2,59),$chr(2)))
  if ($gettok(%1,3,59) != $gettok(%2,3,59)) { var %style21 = $+($chr(3), $gettok(%1,3,59), %style12) | var %style12 = $+($chr(3), $gettok(%2,3,59),%style12) }
  else var %style21 = %style12 

  var %t = $replace($1-,</s1><s2>,%style12,</s2><s1>,%style21)
  ;var %t = $replace(%t,</s1> <s2>,%style102,</s2> <s1>,%style201)
  var %t = $replace(%t,<s1>,%style1,</s1>,%style01,<s2>,%style2,</s2>,%style02)

  return %t
}

alias -l cheerupinicheck {
  if (!$exists(%cheerupini)) writeini %cheerupini setup style1 0
  if ($numtok($readini(%cheerupini,setup,style1),59) != 3) writeini %cheerupini setup style1 0;0;0
  if ($numtok($readini(%cheerupini,setup,style2),59) != 3) writeini %cheerupini setup style2 0;0;0
  if (!$readini(%cheerupini,setup,prefix)) writeini %cheerupini setup prefix 0
  if (!$readini(%cheerupini,setup,spacefront)) writeini %cheerupini setup spacefront 0
  if (!$readini(%cheerupini,setup,spacebehind)) writeini %cheerupini setup spacefront 0
  if (!$readini(%cheerupini,setup,option)) || ($readini(%cheerupini,setup,option) < 1) || ($readini(%cheerupini,setup,option) > 3) writeini %cheerupini setup option 1
  if ($right($readini(%cheerupini,setup,words),1) != $chr(59)) writeini %cheerupini setup words $readini(%cheerupini,setup,words) $+ $chr(59)

  var %i = 1
  var %w = $readini(%cheerupini,setup,words)
  var %n = $numtok(%w,59)
  while (%i <= %n) {
    var %v = $gettok(%w,%i,59)
    var %t = $readini(%cheerupini,words,%v)
    if (!%t) writeini %cheerupini words %v NULL???
    inc %i
  }
}

alias -l cheeruprulesnr {
  if ($1 == 1) return 1. Don't replace anything
  elseif ($1 == 2) return 2. Only replace text
  elseif ($1 == 3) return 3. Replace without colors
  else return ERROR
}

alias -l cheerupversion return 2.41

on *:load {
  echo -s 2L5oaded: 2Cheer-Up Text4 $cheerupversion
  echo -s 2S5etup, type: 2/cheerupsetup
  %cheerupini = " $+ $scriptdirCheerUp.ini $+ "
  %cheerupbmp = " $+ $scriptdircheerup.bmp $+ "
  %cheerupcolor = " $+ $scriptdircolor.bmp $+ "
  cheerupinicheck
}

on *:unload {
  echo -s 2U5nloaded: 2Cheer-Up Text4 $cheerupversion
  unset %cheerupini, %cheerupbmp, %cheerupcolor
}
